; x68k demo "Nascent0"
;
; code by DamageX, music by Askai
;
; assembled with HAS.X (high speed assembler)
; (which doesn't support including a binary file!?!?!?!?!?!?)
;

        .text

 ;       clr.l -(a7)
;        dc.w $FF20      ; get user/supervisor mode
 ;       move.l d0,(a7)

        lea vars,a0

        lea xymfile,a1
        move.l a1,$5C(a0)       ; init music data address pointer
        move.l a1,$60(a0)       ; (and loop address, in case it isn`t set)

        bsr quietfm

        lea scrollmsg,a1
        move.l a1,$68(a0)       ; init scroll text pointer

        moveq #$C0,d0
        trap #15        ; IOCS SP_INIT

        ; setup sprite attributes
        lea $EB0000,a2
        move.w #16,d0
        move.w #15,d3
        move.w #42,d4
a180:
        move.w d3,(a2)+         ; h position
        move.w #$D0,(a2)+       ; v position
        move.w d4,(a2)+         ; gfx
        move.w #3,(a2)+         ; priority
        add.w #16,d3
        dbra d0,a180

        ; zero out unused sprites
        move.w #$1BB,d0
        moveq #0,d1
a181:
        move.w d1,(a2)+
        dbra d0,a181


        ; get vertical blank interrupt
        lea vbint,a1
        moveq #1,d1
        moveq #$6C,d0
        trap #15        ; IOCS VDISPST
        cmp.l #0,d0
        beq intgood

        lea $0000,a1
        moveq #$6C,d0
        trap #15        ; IOCS VDISPST
        lea vbint,a1
        moveq #1,d1
        moveq #$6C,d0
        trap #15        ; IOCS VDISPST
        cmp.l #0,d0
        bne noint
intgood:

        moveq #14,d1    ; 256x256x16bit
        moveq #$10,d0
        trap #15        ; IOCS CRTMOD

        moveq #$90,d0
        trap #15        ; IOCS G_CLR_ON

        moveq #$AF,d0
        trap #15        ; cursor off

        move.l #$C0F080,$50(a0)          ; rendering screen address

        bsr cleargpal

        lea $C00000,a1
        bsr drawcrap
        lea $C40000,a1
        bsr drawcrap

        ; initialize 3D model
        lea cubemod,a1
        move.w $04(a1),d0
        move.w d0,$08(a0)    ; number of verteces
        move.w $06(a1),d1
        move.w d1,$0A(a0)    ; number of polygons
        move.w $08(a1),d2
        move.w d2,$0C(a0)    ; number of lines

        add.w #12,a1

        ; fix byte order in vertex+normal data :(
        add.w d1,d0
        move.w d0,d3
        asl.w #1,d3
        add.w d0,d3
        subq.w #1,d3
a109:
        move.l (a1),d4
        rol.w #8,d4
        swap d4
        rol.w #8,d4
        move.l d4,(a1)+
        dbra d3,a109

        move.l a1,$10(a0)       ; save address

        ; fix byte order in polygon data :(
        asl.w #2,d1
        beq a170
        subq.w #1,d1
a110:
        move.w (a1),d4
        rol.w #8,d4
        move.w d4,(a1)+
        dbra d1,a110
a170:

        ; fix byte order in lines data :(
        asl.w #1,d2
        beq a171
        subq.w #1,d2
a111:
        move.w (a1),d4
        rol.w #8,d4
        move.w d4,(a1)+
        dbra d2,a111
a171:


        ; copy font to sprite SRAM

        lea sprfont,a1
        lea $EB8000,a2
        move.w #$FFF,d0
a179:
        move.w (a1)+,(a2)+
        dbra d0,a179


        ; sprite palette
        lea $E82202,a2
        move.w #$8420,(a2)+
        move.w #$FFFF,(a2)

        moveq #$C1,d0
        trap #15        ; IOCS SP_ON


        ; start of rendering loop
a107:

        bsr transforms
        bsr cleararea
        bsr polysort
        bsr rendersolid

        ; check for keyboard input
        moveq #1,d0
        trap #15        ; IOCS KEYSNS
        cmp.l #0,d0
        bne alldone

        ; check for music loop (demo ends after n loops)
        moveq #2,d0
        cmp.w $6C(a0),d0
        beq alldone

        ; check whether it is time to transition the background pattern
        move.w (a0),d0
        move.w $58(a0),d1
        beq a192
        cmp.w #2,d1
        beq a193
        cmp.w #5400,d0
        bcs a193
        addq.w #1,d1
        move.w d1,$58(a0)
        lea $C00000,a1
        bsr drawcrap3
        lea $C40000,a1
        bsr drawcrap3
        bra a193
a192:
        cmp.w #2700,d0
        bcs a193
        addq.w #1,d1
        move.w d1,$58(a0)
        lea $C00000,a1
        bsr drawcrap2
        lea $C40000,a1
        bsr drawcrap2
a193:


        bsr waitv

        ; swap screens
        move.w #256,d3
        move.l #$C0F080,d0
        cmp.l $50(a0),d0
        bne a159
        move.l #$C4F080,d0
        moveq #0,d3
a159:
        move.l d0,$50(a0)
        moveq #0,d2
        moveq #1,d1
        moveq #$B3,d0
        trap #15

        bra a107

alldone:
        ; disable vbint
        lea $0000,a1
        moveq #$6C,d0
        trap #15        ; IOCS VDISPST

        moveq #16,d1    ; 768x512x4bit
        moveq #$10,d0
        trap #15        ; IOCS CRTMOD

        moveq #$AE,d0
        trap #15        ; IOCS cursor on

        bra exit
noint:
        pea (msgnoint)
        dc.w $FF09	; call DOS print
        addq.l #4,a7	; fix stack pointer
exit:
        bsr quietfm
        dc.w $FF00	; call DOS exit

cleargpal:
        moveq #0,d0
        moveq #0,d1
        lea $E82000,a1
a100:
        move.b d0,(a1)+                
        move.b d0,(a1)+                
        addq.w #1,d1
        cmp.w #256,d1
        bne a100
        rts

setgpal:
        moveq #0,d0
        moveq #1,d1
        lea $E82000,a1
a104:
        move.b d0,(a1)+                
        move.b d1,(a1)+                
        move.b d0,(a1)+                
        move.b d1,(a1)+                
        addq #2,d0
        addq #2,d1

        cmp.w #256,d0
        bne a104
        rts

copygpal:
        moveq #0,d6
        lea $E82000,a1
        lea rampal,a2
a108:
        move.b (a2)+,d2 
        move.b (a2)+,d3
        move.b (a2)+,d4
        move.b (a2)+,d5
        move.b d3,(a1)+                
        move.b d5,(a1)+                
        move.b d2,(a1)+                
        move.b d4,(a1)+                
        addq.b #1,d6
        bpl a108
        rts

waitv:
        move.w (a0),d7
a105:
        move.w (a0),d6
        cmp.w d6,d7
        beq a105
        rts

transforms:

        ; lookup sin/cos values from table
        lea sintabl,a1
        lea ttab,a4

        moveq #0,d0
        move.w #$3FFE,d6
        move.w #$1000,d7

        move.w $14(a0),d0
        bsr cslookup
        move.w $16(a0),d0
        bsr cslookup
        move.w $18(a0),d0
        bsr cslookup
        
        ; process the entire list of verteces
        move.w $08(a0),d1       ; number of verts
        move.w $0A(a0),d2       ; number of polys
        add.w d2,d1
        lea cubemod+12,a2
        lea vbuffer,a3
        lea ttab,a4

a112:
        ; axy rotation
        move.w (a4),d6          
        move.w $02(a4),d7

        move.l (a2),d0
        muls.w d7,d0         ; cos*x
        move.l $04(a2),d2
        muls.w d6,d2         ; -sin*y
        sub.l d2,d0             ; nx (*32K)
        add.l d0,d0
        swap d0

        move.l $04(a2),d3
        muls.w d7,d3         ; cos*y
        move.l (a2),d2
        muls.w d6,d2         ; sin*x
        add.l d2,d3             ; ny (*32K)
        add.l d3,d3
        swap d3

        ; axz rotation
        move.w $06(a4),d6          
        move.w $08(a4),d7

        move.l d0,d4
        muls.w d7,d4         ; cos*nx
        move.l $08(a2),d2
        muls.w d6,d2         : -sin*z
        sub.l d2,d4             ; x final (*32K)

        move.l $08(a2),d5
        muls.w d7,d5       ; cos*z
        muls.w d6,d0       ; sin*nx
        add.l d0,d5             ; nz (*32K)
        add.l d5,d5
        swap d5

        ; ayz rotation
        move.w $0C(a4),d6          
        move.w $0E(a4),d7

        move.l d5,d2
        move.l d3,d0
        muls.w d7,d2         ; cos*nz
        muls.w d6,d0          ; -sin*ny
        sub.l d0,d2             ; z final (*32K)

        muls.w d7,d3       ; cos*ny
        muls.w d6,d5       ; sin*nz
        add.l d5,d3             ; y final (*32K)

        swap d4         ; x
        swap d3         ; y
        swap d2         ; z
                    
        add.w #12,a2

        ; zoom and divide by distance

        muls.w #105,d4
        muls.w #120,d3
;        muls.w #90,d4
 ;       muls.w #102,d3

        move.w d2,d5
        add.w #200,d5
        bne a123
        moveq #1,d5             ; no dividing by zero!
a123:

        divs.w d5,d4
        add.w #64,d4
        and.w #127,d4

        divs.w d5,d3
        add.w #64,d3
        and.w #127,d3

        ; store transformed x,y,z in vbuffer
        move.w d4,(a3)+
        move.w d3,(a3)+
        move.w d2,(a3)+
        addq.l #2,a3

        subq.w #1,d1
        cmp.w #0,d1
        bne a112
        
        rts

cslookup:
        and.w d6,d0
        move.w (a1,d0.w),(a4)+
        add.w d7,d0
        and.w d6,d0
        move.w (a1,d0.w),(a4)+
        add.w d7,d0
        and.w d6,d0
        move.w (a1,d0.w),(a4)+
        rts


cleararea:
        move.l $50(a0),a2
        move.l #$3F3F3F3F,d3

        move.w #$7F,d1
a127:
        move.w #$3F,d2
a126:
;        move.l (a2),d4
;        and.l d3,d4
;        move.l d4,(a2)+
        and.l d3,(a2)+
        dbra d2,a126
        add.w #$300,a2
        dbra d1,a127
        rts



rendersolid:
        lea vbuffer,a2          ; transformed verteces
        lea pzbuffer,a4         : polygon average Z table
        lea polypals,a5         ; palette assignments

        move.w $4E(a0),$0E(a0)  ; number of polys

a130:
        move.l (a4)+,d1
        asl.w #1,d1
        move.w (a5,d1.w),$4C(a0)        ; color

        move.l $10(a0),a1       ; polygon data address
        asl.w #2,d1
        add.w d1,a1

        move.w (a1)+,d1
        asl.w #3,d1
        move.w (a2,d1.w),d2             ; x1
        swap d2
        move.w $02(a2,d1.w),d2          ; y1

        move.w (a1)+,d1
        asl.w #3,d1
        move.w (a2,d1.w),d3             ; x2
        swap d3
        move.w $02(a2,d1.w),d3          ; y2

        move.w (a1)+,d1
        asl.w #3,d1
        move.w (a2,d1.w),d4             ; x3
        swap d4
        move.w $02(a2,d1.w),d4          ; y3

        move.w (a1),d1
        asl.w #3,d1
        move.w (a2,d1.w),d5             ; x4
        swap d5
        move.w $02(a2,d1.w),d5          ; y4

        ; rotate the vertex list until highest point is first
a134:
        cmp.w d2,d3
        blt a132
        cmp.w d2,d4
        blt a132
        cmp.w d2,d5
        bge a133
a132:
        move.l d2,d1
        move.l d3,d2
        move.l d4,d3
        move.l d5,d4
        move.l d1,d5
        bra a134
a133:
        ; store in RAM
        lea vtab,a3
        move.l d2,(a3)+
        move.l d3,(a3)+
        move.l d4,(a3)+
        move.l d5,(a3)

        ; we always START drawing (across each scanline)
        ; at the point 1, moving down the sides 1-2 and 1-4
        ; when either point 2 or point 4 are reached, then the destination
        ; changes to point 3, etc.
        ; then drawing ends when left and right sides meet

        ; determine direction of top righthand edge
        move.w #4,$42(a0)
        move.w $30(a0),d2
        move.w $32(a0),d3
        move.w $34(a0),d6
        move.w $36(a0),d7
        sub.w d3,d7
        sub.w d2,d6
        moveq #1,d1             
        tst.w d6
        bpl a137
        moveq #-1,d1
        not.w d6
a137:
        move.w d1,$46(a0)
        move.w d6,$4A(a0)
        move.w d2,d1
        ; determine direction of top lefthand edge
        move.w #12,$40(a0)
        move.w $3C(a0),d4
        move.w $3E(a0),d5
        sub.w d3,d5
        sub.w d1,d4
        moveq #1,d0
        tst.w d4
        bpl a139
        moveq #-1,d0
        not.w d4
a139:
        move.w d0,$44(a0)
        move.w d4,$48(a0)
        moveq #0,d4
        ; d0 free
        ; d1 Xl, d2 Xr, d3 Y
        ; d4 XFl:XFr (fractions)
        ; d5 YMl (magnitude)
        ; d6 free
        ; d7 YMr
        ; "left" side is not necessarily to the left of "right" side!!
a135:
        ; plot pointS
        move.l $50(a0),a3
        moveq #0,d0
        move.b d3,d0
        asl.w #8,d0
        asl.l #2,d0
        add.w d1,d0
        add.w d1,d0
        add.l d0,a3             ; starting pixel address

        move.w $4C(a0),d0       ; "color"
        move.w d2,d6
        sub.w d1,d6
        bpl a141                ; drawing left or right?
        neg.w d6
        addq.l #2,a3
a140:
        or.w d0,-(a3)
        dbra d6,a140
        bra a154
a141:
        or.w d0,(a3)+
        dbra d6,a141
a154:

        move.w $42(a0),d0
        cmp.w $32(a0,d0.w),d3     ; check whether right edge has met a corner
        bne a142
a147:
        cmp.w $40(a0),d0        ; have both sides met? if so we are done
        beq a131
        move.w $30(a0,d0.w),d2
        addq.w #4,d0            ; turn the corner
;        cmp.w #16,d0            ; no more corners!
 ;       beq a131
        move.w d0,$42(a0)
        move.w $30(a0,d0.w),d6
        move.w $32(a0,d0.w),d7
        sub.w d3,d7
        bmi a131                ; just say no to bowties
        beq a147                ; is it really a corner?
        sub.w d2,d6
        moveq #1,d0             
        tst.w d6
        bpl a148
        moveq #-1,d0
        not.w d6
a148:
        move.w d0,$46(a0)
        move.w d6,$4A(a0)
a142:

        move.w $40(a0),d0
        cmp.w $32(a0,d0.w),d3     ; check whether left edge has met a corner
        bne a152
a157:
        cmp.w $42(a0),d0        ; have both sides met? if so we are done
        beq a131
        move.w $30(a0,d0.w),d1
        subq.w #4,d0            ; turn the corner
;        beq a131                ; no more corners!
        move.w d0,$40(a0)
        move.w $30(a0,d0.w),d6
        move.w $32(a0,d0.w),d5
        sub.w d3,d5
        bmi a131                ; just say no to bowties
        beq a157                ; is it really a corner?
        sub.w d1,d6
        moveq #1,d0             
        tst.w d6
        bpl a158
        moveq #-1,d0
        not.w d6
a158:
        move.w d0,$44(a0)
        move.w d6,$48(a0)
a152:

        add.l $48(a0),d4        ; add to both X fractions in one opcode
a144:
        cmp.w d4,d7             ; check the right one for overflow
        bhi a143
        sub.w d7,d4
        add.w $46(a0),d2
        bra a144
a143:
        swap d4                 ; now the left
a146:
        cmp.w d4,d5
        bhi a145
        sub.w d5,d4
        add.w $44(a0),d1
        bra a146
a145:
        swap d4                 ; swap back
        addq.w #1,d3            ; next line
        bra a135

a131:
        ; loop for the next polygon
        subq.w #1,$0E(a0)
        bne a130
        rts

polysort:
        move.l $10(a0),a1       ; polygon data address
        lea vbuffer,a2          ; transformed verteces
        lea pzbuffer,a3         : polygon average Z table

        move.l a2,a5
        move.w $08(a0),d0       ; number of verteces
        asl.w #3,d0
        add.w d0,a5             ; normals data address

        move.w $0A(a0),d7       ; number of polys
        moveq #0,d6
        moveq #0,d5

a129:
        move.w $04(a5),d0       ; backface culling
        cmp.w #1000,d0          ; visibility threshold fine tuning
;        cmp.w #1300,d0
        blt a160
;        bmi a160

        move.w (a1),d0
        asl.w #3,d0
        move.w $04(a2,d0.w),d1          ; z1
        move.w $02(a1),d0
        asl.w #3,d0
;        move.w $04(a2,d0.w),d2           ; z2
        add.w $04(a2,d0.w),d1           ; z2
        move.w $04(a1),d0
        asl.w #3,d0
;        move.w $04(a2,d0.w),d3           ; z3
        add.w $04(a2,d0.w),d1           ; z3
        move.w $06(a1),d0
        asl.w #3,d0
;        move.w $04(a2,d0.w),d4           ; z4
        add.w $04(a2,d0.w),d1           ; z4

;a165:
;        cmp.w d1,d2
;        bgt a166
;        cmp.w d1,d3
;        bgt a166
;        cmp.w d1,d4
;        ble a167
;a166:
;        move.l d1,d0
;        move.l d2,d1
;        move.l d3,d2
;        move.l d4,d3
;        move.l d0,d4
;        bra a165
;a167:

        swap d1
        move.w d6,d1
        move.l d1,(a3)+
        addq.w #1,d5
a160:
        addq.l #8,a1
        addq.l #8,a5

        addq.w #1,d6
        cmp.w d6,d7
        bne a129

        move.w d5,$4E(a0)       ; final polygon count

        move.l #$80000000,(a3)  ; mark the end of table with a min value

        ; now sort the table
        lea pzbuffer,a3         : polygon average Z table

a161:
        subq.w #1,d5
        beq a163
a164:
        move.l (a3)+,d0
        move.l a3,a4
        move.w d5,d6
a162:
        cmp.l (a4)+,d0
        dblt d6,a162
        tst.w d6
        bmi a161
        subq.l #4,a3
        subq.l #4,a4
        move.l (a4),d1
        move.l d0,(a4)
        move.l d1,(a3)
        bra a164
a163:
        rts

drawcrap:
        ; make a grid/gradient pattern
        moveq #0,d0
a101:
        move.w d0,d4
        asr.w #2,d4
        asl.w #8,d4
        moveq #0,d1
a102:
        move.w d1,d2
        asr.w #2,d2
        add.w d4,d2
        move.w d2,(a1)+
        addq.w #1,d1
        cmp.w #256,d1
        bne a102

        add.w #$200,a1

        addq.w #1,d0
        cmp.w #256,d0
        bne a101
        rts


drawcrap2:
        ; make a weird crosshatch pattern
        moveq.l #0,d7
        move.w #$3F3F,d6
        move.w #255,d3
a186:
        move.w d7,d4
        move.w #255,d5
a187:
        move.w d4,d2
        asr.w #1,d2
        and.w d6,d2
        move.w d2,(a1)+
        add.w #$0100,d4
        addq.b #1,d4
        dbra d5,a187

        add.w #$200,a1

        add.w #$0100,d7
        subq.b #1,d7
        dbra d3,a186
        rts

drawcrap3:
        move.w #$3F3F,d0
        ; make a radial pattern
        moveq.l #0,d7   ; y coord
a188:
        moveq.l #0,d6   ; x coord

        move.w #128,d5
        sub.w d7,d5
        muls.w d5,d5

        moveq.l #4,d2           ; beginning of square root search 

a189:
        move.w #128,d4
        sub.w d6,d4
        muls.w d4,d4

        add.w d5,d4
        ; find square root to determine distance from center
a190:
        move.w d2,d3
        mulu.w d3,d3
        cmp.w d3,d4
        blt a191
        addq.w #4,d2
        bra a190
a191:

        move.w d2,d3
        subq.w #4,d2    ; keep root value (minus 4) to narrow the next search

        asr.w #2,d3
        moveq.l #63,d1
        sub.w d3,d1
        asl.w #7,d3
        or.w d1,d3
        and.w d0,d3

        move.w d3,(a1)+
        addq.w #1,d6
        cmp.w #256,d6
        bne a189

        add.w #$200,a1

        addq.w #1,d7
        cmp.w #256,d7
        bne a188
        rts

quietfm:
        moveq #$60,d1
a177:
        moveq #127,d2
        moveq #$68,d0
        trap #15        ; IOCS OPMSET
        addq.b #1,d1
        bpl a177
        rts


regs    reg d0-d7/a0-a5

vbint:
        movem.l regs,-(a7)

        lea vars,a0
        addq.w #1,(a0)

        bsr buildpalette
        bsr copygpal
        addq.w #1,$04(a0)       ; increment index to "scroll" the color bar
        addq.w #2,$06(a0)

        add.w #9,$14(a0)       ; rotate
        add.w #19,$16(a0)       ;
        add.w #29,$18(a0)       ;

        ; scale color gradients up/down
        move.w $54(a0),d0
        add.w $64(a0),d0
        cmp.w #$500,d0
        beq a168
        cmp.w #$200,d0
        bne a169
a168:
        neg.w $64(a0)
a169:
        move.w d0,$54(a0)


        bsr xymplay

        ; scroll the text sprites
        lea $EB0000,a2
        lea sinescroll,a1
        move.w (a2),d0
        subq.w #1,d0
        and.w #15,d0
        move.w d0,d4
        asl.w #1,d4
        move.w #16,d1
a182:
        move.w d0,(a2)+          ; h position
        move.w d1,d3
        and.w #1,d3
        asl.w #5,d3
        add.w d4,d3
        move.w $00(a1,d3.w),(a2)+       ; v position
        add.w #4,a2
        add.w #16,d0
        dbra d1,a182
        
        and.w #15,d0
        cmp.w #15,d0
        bne a183
        ; advance the string
        lea $EB0004,a2
        move.w #15,d1
a184:
        move.w $08(a2),(a2)
        add.w #8,a2
        dbra d1,a184
        move.l $68(a0),a1
        moveq #0,d0
        move.b (a1)+,d0
        move.l a1,$68(a0)
        cmp.b #$20,d0
        bne a185
        add.b #75,d0
a185:
        sub.b #65,d0
        move.w d0,(a2)
a183:

        movem.l (a7)+,regs
        rte

buildpalette:
        move.w $04(a0),d0
        move.w $06(a0),d1

        asl.w #7,d0
        asl.w #7,d1

        move.w $54(a0),d6
;        move.w $56(a0),d7

        lea rampal,a1
        lea palpat,a2
        lea palpat2,a3
        moveq #63,d2
a106:
        move.w d0,d3
        asr.w #8,d3
        and.w #126,d3
        add.w d6,d0

        move.w d1,d4
        asr.w #8,d4
        and.w #126,d4
;        add.w d7,d1
        add.w d6,d1

        ; write value for second 64 "palette" entries        
        move.w $00(a3,d3.w),d5
        move.b $01(a3,d4.w),d5
        move.w d5,$80(a1)

        ; write value for third 64 "palette" entries        
        move.w $00(a2,d3.w),d5
        move.b $01(a2,d4.w),d5
        not.w d5
        move.w d5,$100(a1)

        ; write value for fourth 64 "palette" entries        
        move.w $00(a3,d3.w),d5
        move.b $01(a3,d4.w),d5
        not.w d5
        move.w d5,$180(a1)

        ; write value for FIRST 64 "palette" entries        
        move.w $00(a2,d3.w),d5
        move.b $01(a2,d4.w),d5
        move.w d5,(a1)+

        dbra d2,a106
        rts

xymplay:
        move.b $5A(a0),d0       ; check countdown
        beq a172
        subq.b #1,d0
        move.b d0,$5A(a0)
        rts
a172:
        move.l $5C(a0),a2       ; load xym pointer
        move.l #$E90000,a1
a173:
        ; read bytes from the VGM data
        move.b (a2)+,d1
        move.b (a2)+,d2
;        cmp.b #0,d1
        tst.b d1
        bne a174
        cmp.b #254,d2
        bne a175
        move.l a2,$60(a0)       ; store music loop address
        bra a173
a175:
        cmp.b #255,d2
        bne a176
;        move.l $60(a0),$5C(a0)  ; load music loop address
 ;       rts
        move.l $60(a0),a2
        addq.w #1,$6C(a0)       ; increment loop counter
        bra a173
a176:
        ; wait frames
        move.b d2,$5A(a0)
        move.l a2,$5C(a0)
        rts
a174:
        ; set YM2151 registers

        moveq #$68,d0
        trap #15        ; IOCS OPMSET

;a178:
;        move.b $03(a1),d0
;        bmi a178
;        move.b d1,$01(a1)
;        move.b d2,$03(a1)

        bra a173


vars:
        dc.w 0          ; $00 VB interrupt counter
        dc.w 0          ; $02 OPM timer interrupt counter
        dc.w 0          ; $04 index into green gradient color list
        dc.w 0          ; $06 index into blue gradient color list
        dc.w 0          ; $08 number of verteces
        dc.w 0          ; $0A number of polygons
        dc.w 0          ; $0C number of lines
        dc.w 0          ; $0E misc
        dc.l 0          ; $10 address of polygons data table
        dc.w 0          ; $14 axy
        dc.w 0          ; $16 axz
        dc.w 0          ; $18 ayz
ttab:   dc.w 0,0,0      ; $1A-1E axy sin,cos,-sin
        dc.w 0,0,0      ; $20-24 axz sin,cos,-sin
        dc.w 0,0,0      ; $26-2A ayz sin,cos,-sin
        dc.l 0          ; $2C address of normals data
vtab:   dc.w 0,0        ; $30-32 vertex 1 x,y
        dc.w 0,0        ; $34-36 vertex 2 x,y
        dc.w 0,0        ; $38-3A vertex 3 x,y
        dc.w 0,0        ; $3C-3E vertex 4 x,y
        dc.w 0          ; $40 left edge destination point
        dc.w 0          ; $42 right edge destination point
        dc.w 0          ; $44 left edge X direction
        dc.w 0          ; $46 right edge X direction
        dc.w 0          ; $48 left edge X magnitude
        dc.w 0          ; $4A right edge X magnitude
        dc.w 0          ; $4C bitmask to be applied when drawing pixels
        dc.w 0          ; $4E number of (sorted) polygons to draw
        dc.l 0          ; $50 base address of framebuffer to draw in
        dc.w $200       ; $54 palette high byte gradient scale factor
        dc.w $200       ; $56 palette low byte gradient scale factor
        dc.w 0          ; $58 which BG pattern is being displayed
        dc.w 0          ; $5A xym player wait countdown
        dc.l 0          ; $5C xym data address
        dc.l 0          ; $60 xym loop address
        dc.w 2          ; $64 scale factor derivative
        dc.w 2          ; $66 scale factor derivative
        dc.l 0          ; $68 scroll text pointer
        dc.w 0          ; $6C music player loop counter

sinescroll:
;        dc.w $D0,$D4,$D7,$DA,$DC,$DD,$DE,$DF,$DF,$DF,$DE,$DD,$DB,$D9,$D6,$D2
 ;       dc.w $D0,$CC,$C9,$C6,$C4,$C3,$C2,$C1,$C1,$C1,$C2,$C3,$C5,$C7,$CA,$CE
        dc.w $D0,$D2,$D4,$D6,$D7,$D8,$D9,$DA,$DB,$DC,$DD,$DD,$DE,$DE,$DE,$DF
        dc.w $DF,$DF,$DF,$DE,$DE,$DE,$DD,$DD,$DC,$DB,$DA,$D9,$D7,$D5,$D3,$D1

sintabl:
        .include sintabl3.ugh

cubemod:
        .include cube2.ugh
;        .include bign.ugh
;        .include sphere5.ugh

palpat:
        dc.w $0000,$0802,$1004,$1806,$2008,$280A,$300C,$380E
        dc.w $4010,$4812,$5014,$5816,$6018,$681A,$701C,$781E
        dc.w $8020,$8822,$9024,$9826,$A028,$A82A,$B02C,$B82E
        dc.w $C030,$C832,$D034,$D836,$E038,$E83A,$F03C,$F83E

        dc.w $F83E,$F03C,$E83A,$E038,$D836,$D034,$C832,$C030
        dc.w $B82E,$B02C,$A82A,$A028,$9826,$9024,$8822,$8020
        dc.w $781E,$701C,$681A,$6018,$5816,$5014,$4812,$4010
        dc.w $380E,$300C,$280A,$2008,$1806,$1004,$0802,$0000

palpat2:
        dc.w $0400,$0C00,$1402,$1C02,$2404,$2C04,$3406,$3C06
        dc.w $4508,$4D08,$550A,$5D0A,$650C,$6D0C,$750E,$7D0E
        dc.w $8610,$8E10,$9612,$9E12,$A614,$AE14,$B616,$BE16
        dc.w $C718,$CF18,$D71A,$DF1A,$E71C,$EF1C,$F71E,$FF1E

        dc.w $FF1E,$F71E,$EF1C,$E71C,$DF1A,$D71A,$CF18,$C718
        dc.w $BE16,$B616,$AE14,$A614,$9E12,$9612,$8E10,$8610
        dc.w $7D0E,$750E,$6D0C,$650C,$5D0A,$550A,$4D08,$4508
        dc.w $3C06,$3406,$2C04,$2404,$1C02,$1402,$0C00,$0400

polypals:
        dc.w $4040,$4040,$8080,$8080,$C0C0,$C0C0

;        dc.w $4040,$4040,$4040,$4040,$4040,$4040
;        dc.w $8080,$8080,$8080,$8080,$8080
;        dc.w $C0C0,$C0C0,$C0C0,$C0C0,$C0C0

;        dc.w $4040,$8080,$C0C0,$4040,$8080,$C0C0,$4040,$8080,$C0C0
;        dc.w $4040,$8080,$C0C0,$4040,$8080,$C0C0,$4040,$8080,$C0C0
;        dc.w $4040,$8080,$C0C0,$4040,$8080,$C0C0,$4040,$8080,$C0C0
;        dc.w $4040,$8080,$C0C0,$4040,$8080,$C0C0,$4040,$8080,$C0C0
;        dc.w $4040,$8080,$C0C0,$4040,$8080,$C0C0,$4040,$8080,$C0C0
;        dc.w $4040,$8080,$C0C0,$4040,$8080,$C0C0,$4040,$8080,$C0C0
;        dc.w $4040,$8080,$C0C0,$4040,$8080,$C0C0,$4040,$8080,$C0C0
;        dc.w $4040,$8080,$C0C0,$4040,$8080,$C0C0,$4040,$8080,$C0C0
;        dc.w $4040,$8080,$C0C0,$4040,$8080,$C0C0,$4040,$8080,$C0C0

sprfont:
        .include font.ugh

xymfile:
;        .include dance.ugh
;        .include nascent0.ugh
        .include testvgm.ugh
        dc.b 0,255

msgnoint:
        dc.b "cannot get interrupt",13,10,0

scrollmsg:
        dc.b "GREETINGS",105," ",91,92,103,103,104,105
        dc.b "   NASCENT PRESENTS   NASCENT",93
        dc.b "   A SMALL DEMO WHICH RUNS ON THE ORIGINAL SPEC"
        dc.b " SHARP X",99,101,93,93,93," FROM ",94,102,101,100

        dc.b "   DRAWING UNTEXTURED UNSHADED POLYGONS IN "
        dc.b 99,101,"K ASSEMBLY IS NOT TOO HARD"
        dc.b "   WHO NEEDS TEXTURES ANYWAY"
        dc.b "   BUT IT IS A GOOD THING THAT A SPINNING"
        dc.b " CUBE DOES NOT NEED A Z BUFFER",106,106,106
        dc.b "   IT IS FUN TO MODIFY THE COLOR LOOKUP TABLE"
        dc.b " IN ",99,98,98,96,99," COLOR MODE"
        dc.b "   NOW IF ONLY ONE COULD COMPREHEND THE DMA CONTROLLER"
        dc.b "   MUSIC BY ASKAI"
        dc.b "   CODE BY DAMAGEX"

        dc.b "              THE END",105,"                  "
        dc.b "                                              "
        dc.b 106,106,106,106,106,106,106,106

; 91 - ko
; 92 - n
; 93~102 - 0~9
; 103 - O
; 104 - wa
; 105 - !
; 106 - .
; 107 - space

        .bss

        .even

rampal:
        ds.l 128

vbuffer:
        ds.l 512

pzbuffer:
        ds.l 256

rbuffer:
        ds.w 16384
